/* 
 * For solving the problem, I am using Kruskal's Algorithm
 * 
 * 
 * The program is coded, using parts from rewritten base algorithm copied from:
 * http://krishami.com/2011/12/implementation-of-kruskals-algorithm-in-java/
 * License: Eclipse Public License (free to use)
 * 
 * 
 * For weight of the edges of the graph I am using the following formula:
 * weight = distance + distance / number of routes between the two cities
 * 
 * */

package graph;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.TreeSet;


public class Start {
	
	public static void main(String[] args)
    {
		int i,j,point;
		int[][] routes;
		File in = new File("graph.in");
		File out = new File("graph.out");
		FileInputStream fis = null;
		FileOutputStream fos = null;
		PrintWriter pw = null;
		try{
			fis = new FileInputStream(in);
			fos = new FileOutputStream(out);
			pw = new PrintWriter(out);
			if (!out.exists()) {
				out.createNewFile();
			}
			byte[] bytes = new byte[(int) in.length()];
			int num_cities;
			int num_highways;
			int startCity;
			int endCity;
			double dist;
			fis.read(bytes);
			String[] fileInfo = new String(bytes).trim().split("\\s+");
			num_cities=Integer.parseInt(fileInfo[0]);
			num_highways=Integer.parseInt(fileInfo[1]);
			TreeSet<Highway> highways = new TreeSet<Highway>();
			routes = new int[num_cities][num_cities];
			point=((num_highways*3)+2);
			for(i=0;i<num_cities;i++){
				for(j=0;j<num_cities;j++){
					routes[i][j] = Integer.parseInt(fileInfo[point]);
					point++;
					if(i >= fileInfo.length){
						break;
					}
				}
			}
			for(i=0;i<num_highways;i++){
				startCity = Integer.parseInt(fileInfo[((3*i)+2)]);
				endCity = Integer.parseInt(fileInfo[((3*i)+3)]);
				dist = Double.parseDouble(fileInfo[((3*i)+4)]);
				highways.add(new Highway(startCity,endCity,(dist + (dist/routes[startCity-1][endCity-1])),i+1));
			}
			MyGraph gr = new MyGraph();
			for(Highway hw : highways){
				gr.insertHighway(hw);
			}
			for (Highway hw : gr.getHighways()) {
				pw.write(Integer.toString(hw.getNumberOfHighway())+"\n");
        	}
			
		}
		catch (IOException e) {
			e.printStackTrace();
		}
		finally {
			try {
				if (fis != null)
					fis.close();
				if (fos != null)
					fos.close();
				if (pw != null)
					pw.close();
			} 
			catch (IOException ex) {
				ex.printStackTrace();
			}
		}
    }
}

/* Georgi Georgiev, georgiev.g@dir.bg
 * Student in Technical University of Sofia,
 * Faculty of Computer Systems and Control	
 * */

